=== Makefile ===
#############################################################################
#	Makefile for VRPN libraries.  Needs to be built using 'gmake'.
# Should run on any architecture that is currently supported.  It should
# be possible to build simultaneously on multiple architectures.
#
# On the sgi, both g++ and CC versions are built by default.
#
# Author: Russ Taylor, 10/2/1997
#
# modified:
# * Andrew Roth June 16/2012
#	 * Updates for MacOSX builds for 32/64, 64 bit and Xcode 4.3
# * Jeff Juliano, 10/99
#    * added "make depend"  (see comments at end of this makefile)
#    * changed to use RM, RMF, MV, and MVF
#      these are overridable as follows:
#          gmake RM=/mybin/rm,  or  gmake RMF="/bin/rm -option"
# * Jeff Juliano, 9/1999
#     support for parallel make (see WARNING below)
# * Tom Hudson, 25 Jun 1998
#     Support for n32 ABI on sgi.  (gmake n32)
# * Hans Weber, ???
#     Support for both g++ and native compilers on sgi.
# * Tom Hudson, 13 Feb 1998
#     Build two different libraries:  client (libvrpn) and server
#     (libvrpnserver).  Our solution is to compile twice, once with the
#     flag -DVRPN_CLIENT_ONLY and once without.  Any server-specific code
#     (vrpn_3Space, vrpn_Tracker_Fastrak, vrpn_Flock) should ONLY be
#     compiled into the server library!
#############################################################################

##########################
# common definitions. For non-UNC sites, uncomment one of the lines
# that defines hw_os for the machine you are on in the section just
# below. Then, the code should compile in your environment.
#
#HW_OS := sgi_irix
#HW_OS := pc_linux
#HW_OS := pc_linux64
#HW_OS := pc_linux_ia64
# Try this to cross-compile on a Linux PC for an ARM embedded controller.
#HW_OS := pc_linux_arm
# Try this to cross-compile on a Cygwin PC for an ARM embedded controller.
#HW_OS := pc_cygwin_arm
#HW_OS := pc_cygwin
#HW_OS := pc_FreeBSD
#HW_OS := sparc_solaris
#HW_OS := sparc_solaris_64
#HW_OS := powerpc_aix
#HW_OS := powerpc_macosx
#HW_OS := universal_macosx
#HW_OS := macosx_32_64
#HW_OS := macosx_64
##########################

##########################
# Mac OS X-specific options. If HW_OS is powerpc_macosx or universal_macosx,
# uncomment one line below to choose the minimum targeted OS X version and
# corresponding SDK. If none of the lines below is commented out, 10.5 will
# be the minimum version.  10.7/4.3 removes ppc support.  In Xcode 4.3 - you 
# must now manually install command line tools from: 
# Xcode menu > Preferences > Downloads.
##########################
#MAC_OS_MIN_VERSION := 10.4
#MAC_OS_MIN_VERSION := 10.5
#MAC_OS_MIN_VERSION := 10.6
#MAC_OS_MIN_VERSION := 10.7
#MAC_OS_MIN_VERSION := 10.8

INSTALL_DIR := /usr/local
BIN_DIR := $(INSTALL_DIR)/bin
INCLUDE_DIR := $(INSTALL_DIR)/include
LIB_DIR := $(INSTALL_DIR)/lib

MV = /bin/mv
MVF = $(MV) -f

RM = /bin/rm
RMF = $(RM) -f

ifndef HW_OS
  # hw_os does not exist on FreeBSD at UNC or on CYGWIN
  UNAME := $(shell uname -s)
  ifeq ($(UNAME), FreeBSD)
    HW_OS := pc_FreeBSD
  else
    # pc_cygwin doesn't have HW_OS
    ifeq ($(UNAME), CYGWIN_NT-4.0)
      HW_OS := pc_cygwin
      # On cygwin make is gmake (and gmake doesn't exist)
      MAKE  := make -f $(MAKEFILE)
    else
      ifeq ($(UNAME), CYGWIN_98-4.10)
	    HW_OS := pc_cygwin
	    MAKE := make -f $(MAKEFILE)
      else
        ifeq ($(UNAME), CYGWIN_NT-5.0)
	    HW_OS := pc_cygwin
	    MAKE := make -f $(MAKEFILE)
        else
	    HW_OS := $(shell hw_os)
        endif
      endif
    endif
  endif
endif

# check if its for pxfl
ifdef PBASE_ROOT
  HW_OS := hp_flow
  ifeq ($(PXFL_COMPILER), aCC)
    HW_OS = hp_flow_aCC
  endif
endif

ifeq (,$(strip $(HW_OS)))
$(error You must define HW_OS when calling make. See the makefile for example values)
all:
	@echo "ERROR: You must define HW_OS when calling make. See the makefile for example values." 1>&2
endif

# Which C++ compiler to use.  Default is g++, but some don't use this.
#
# IF YOU CHANGE THESE, document either here or in the header comment
# why.  Multiple contradictory changes have been made recently.

# These should be defaulting to useful values on the platform.
# If they aren't, use gcc.

# C compiler
CC ?= gcc

# C++ compiler
CXX ?= g++

# These probably aren't defaulting to anything useful.
AR := ar ruv
# need default 'ranlib' to be touch for platforms that don't use it,
# otherwise make fails.
RANLIB ?= touch

ifeq ($(FORCE_GPP),1)
  CC := g++
else

  ifeq ($(HW_OS),sparc_solaris)
    CC := /opt/SUNWspro/bin/CC
    AR := /opt/SUNWspro/bin/CC -xar -o
  endif

  ifeq ($(HW_OS),sparc_solaris_64)
    CC := /opt/SUNWspro/bin/CC -xarch=v9a
    AR := /opt/SUNWspro/bin/CC -xarch=v9a -xar -o
  endif

  ifeq ($(HW_OS),powerpc_aix)
    CC := /usr/ibmcxx/bin/xlC_r -g -qarch=pwr3 -w
    RANLIB := ranlib
  endif

  ifeq ($(HW_OS),pc_linux64)
    STANDARD_CFLAGS := -m64 -fPIC
    RANLIB := ranlib
  endif

  ifeq ($(HW_OS),pc_linux)
    STANDARD_CFLAGS := -fPIC
    RANLIB := ranlib
  endif

  ifeq ($(HW_OS), pc_linux_ia64)
    RANLIB := ranlib
  endif

  ifneq (,$(findstring macosx,$(HW_OS)))
    ifndef MAC_OS_MIN_VERSION
      MAC_OS_MIN_VERSION := 10.5
    endif

    # Select which compiler and MAC OS X SDK to use
    MAC_CC := gcc
    MAC_CXX := g++
    ifeq ($(MAC_OS_MIN_VERSION), 10.8)
      MAC_OS_SDK := MacOSX10.8.sdk
    else
      ifeq ($(MAC_OS_MIN_VERSION), 10.7)
        MAC_OS_SDK := MacOSX10.7.sdk
      else
        ifeq ($(MAC_OS_MIN_VERSION), 10.6)
          MAC_OS_SDK := MacOSX10.6.sdk
        else
          ifeq ($(MAC_OS_MIN_VERSION), 10.5)
            MAC_OS_SDK := MacOSX10.5.sdk
          else
            MAC_OS_SDK := MacOSX10.4u.sdk
            MAC_CC := gcc-4.0
            MAC_CXX := g++-4.0
          endif
        endif
       endif
      endif
    endif
 
ifneq (,$(findstring macosx,$(HW_OS)))
  ifeq ($(wildcard /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/$(MAC_OS_SDK)),/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/$(MAC_OS_SDK))
    PATH_TO_DEV := /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/$(MAC_OS_SDK)
    $(info ---> Xcode 4.3+: Platform SDK found.  Setting dev path to $(PATH_TO_DEV)) 
  else
    PATH_TO_DEV := /Developer/SDKs/$(MAC_OS_SDK)
    $(info Xcode 4.3+: Platform SDK not found in /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/$(MAC_OS_SDK)!  Attempting to locate SDK in $(PATH_TO_DEV))
  endif
  CC := $(MAC_CC)
  CXX := $(MAC_CXX)
  STANDARD_CFLAGS := -isysroot /Developer/SDKs/$(MAC_OS_SDK) -mmacosx-version-min=$(MAC_OS_MIN_VERSION)
  SYSLIBS := -framework CoreFoundation -framework IOKit -framework System
endif

  ifeq ($(HW_OS),powerpc_macosx)
    STANDARD_CFLAGS := -arch ppc $(STANDARD_CFLAGS)
    RANLIB := ranlib
    AR := libtool -static -o
  endif

  ifeq ($(HW_OS),universal_macosx)
    STANDARD_CFLAGS := -arch ppc -arch i386 -arch x86_64 $(STANDARD_CFLAGS)
    RANLIB := :
    AR := libtool -static -o
  endif
  
  ifeq ($(HW_OS),macosx_32_64)
    STANDARD_CFLAGS := -arch i386 -arch x86_64 $(STANDARD_CFLAGS)
    RANLIB := :
    AR := libtool -static -o
  endif
  
  ifeq ($(HW_OS),macosx_64)
    STANDARD_CFLAGS := -arch x86_64 $(STANDARD_CFLAGS)
    RANLIB := :
    AR := libtool -static -o
  endif
       
  ifeq ($(HW_OS),pc_linux_arm)
    CC := arm-linux-gcc
    CXX := arm-linux-g++
    RANLIB := arm-linux-ranlib
    AR := arm-linux-ar ruv
  endif

  ifeq ($(HW_OS),pc_cygwin_arm)
    CC := arm-unknown-linux-gnu-gcc
    CXX := arm-unknown-linux-gnu-g++
    RANLIB := arm-unknown-linux-gnu-ranlib
    AR := arm-unknown-linux-gnu-ar ruv
  endif

  ifeq ($(HW_OS),sgi_irix)
   ifndef SGI_ABI
      SGI_ABI := n32
   endif
   ifndef SGI_ARCH
      SGI_ARCH := mips3
   endif
   OBJECT_DIR_SUFFIX := .$(SGI_ABI).$(SGI_ARCH)
   CC := CC -$(SGI_ABI) -$(SGI_ARCH) -LANG:std
   RANLIB := :
  endif

  ifeq ($(HW_OS),hp700_hpux10)
	CC := CC +a1
  endif
  ifeq ($(HW_OS),pc_cygwin)
	CC := g++
  endif
  ifeq ($(HW_OS),sparc_sunos)
	CC := /usr/local/lib/CenterLine/bin/CC
  endif
  ifeq ($(HW_OS), hp_flow_aCC)
	CC := /opt/aCC/bin/aCC
  endif
endif

#ifeq ($(HW_OS),sparc_solaris)
#  AR := /usr/ccs/bin/ar
#endif

##########################
# directories
#

# subdirectory for make
ifeq ($(FORCE_GPP),1)
OBJECT_DIR	 := $(HW_OS)$(OBJECT_DIR_SUFFIX)/g++
SOBJECT_DIR      := $(HW_OS)$(OBJECT_DIR_SUFFIX)/g++/server
AOBJECT_DIR      := $(HW_OS)$(OBJECT_DIR_SUFFIX)/atmellib
GOBJECT_DIR      := $(HW_OS)$(OBJECT_DIR_SUFFIX)/gpsnmealib
else
UNQUAL_OBJECT_DIR := $(HW_OS)$(OBJECT_DIR_SUFFIX)
UNQUAL_SOBJECT_DIR := $(HW_OS)$(OBJECT_DIR_SUFFIX)/server
UNQUAL_AOBJECT_DIR := $(HW_OS)$(OBJECT_DIR_SUFFIX)/atmellib
UNQUAL_GOBJECT_DIR := $(HW_OS)$(OBJECT_DIR_SUFFIX)/gpsnmealib
OBJECT_DIR	 := $(HW_OS)$(OBJECT_DIR_SUFFIX)
SOBJECT_DIR      := $(HW_OS)$(OBJECT_DIR_SUFFIX)/server
AOBJECT_DIR      := $(HW_OS)$(OBJECT_DIR_SUFFIX)/atmellib
GOBJECT_DIR      := $(HW_OS)$(OBJECT_DIR_SUFFIX)/gpsnmealib
endif

# directories that we can do an rm -f on because they only contain
# object files and executables
SAFE_KNOWN_ARCHITECTURES :=	\
	hp700_hpux/* \
	hp700_hpux10/* \
	mips_ultrix/* \
	pc_linux/* \
	sgi_irix.32/* \
	sgi_irix.n32/* \
	sparc_solaris/* \
	sparc_solaris_64/* \
	sparc_sunos/* \
	pc_cygwin/* \
	powerpc_aix/* \
	pc_linux_arm/* \
	powerpc_macosx/* \
	universal_macosx/* \
	macosx_32_64/* \
	macosx_64/* \
	pc_linux64/* \
	pc_linux_ia64/*

CLIENT_SKA = $(patsubst %,client_src/%,$(SAFE_KNOWN_ARCHITECTURES))
SERVER_SKA = $(patsubst %,server_src/%,$(SAFE_KNOWN_ARCHITECTURES))

##########################
# Include flags
#

#SYS_INCLUDE := -I/usr/local/contrib/include -I/usr/local/contrib/mod/include
SYS_INCLUDE :=

ifeq ($(HW_OS),powerpc_macosx)
#   SYS_INCLUDE := -I/usr/include
    SYS_INCLUDE :=-DMACOSX -I../isense
endif

ifeq ($(HW_OS),universal_macosx)
#   SYS_INCLUDE := -I/usr/include
    SYS_INCLUDE :=-DMACOSX -I../isense
endif

ifeq ($(HW_OS),macosx_32_64)
#   SYS_INCLUDE := -I/usr/include
    SYS_INCLUDE :=-DMACOSX -I../isense
endif

ifeq ($(HW_OS),macosx_64)
#   SYS_INCLUDE := -I/usr/include
    SYS_INCLUDE :=-DMACOSX -I../isense
endif

ifeq ($(HW_OS),pc_linux)
    # The following is for the InterSense and Freespace libraries.
    SYS_INCLUDE := -DUNIX -DLINUX -I../libfreespace/include -I./submodules/hidapi/hidapi -I/usr/include/libusb-1.0
	# On linux, build this as c, not c++.
    $(HW_OS)/server/vrpn_Local_HIDAPI.o: EXTRA_FLAGS += -x c
endif

ifeq ($(HW_OS),pc_linux64)
    # The following is for the InterSense and Freespace libraries.
    SYS_INCLUDE := -DUNIX -DLINUX -I../libfreespace/include -I./submodules/hidapi/hidapi -I/usr/include/libusb-1.0
	# On linux, build this as c, not c++.
    $(HW_OS)/server/vrpn_Local_HIDAPI.o: EXTRA_FLAGS += -x c
endif

ifeq ($(HW_OS),pc_linux_arm)
    SYS_INCLUDE := -I/opt/Embedix/arm-linux/include
#   -I/usr/local/contrib/include \
#	  	 -I/usr/local/contrib/mod/include -I/usr/include/bsd \
#		 -I/usr/include/g++
endif

ifeq ($(HW_OS),pc_cygwin_arm)
   SYS_INCLUDE := -I/opt/Embedix/arm-linux/include
#   -I/usr/local/contrib/include \
#	  	 -I/usr/local/contrib/mod/include -I/usr/include/bsd \
#		 -I/usr/include/g++
endif

ifeq ($(HW_OS),sgi_irix)
#  SYS_INCLUDE := -I/usr/local/contrib/mod/include
  SYS_INCLUDE :=
endif

ifeq ($(HW_OS),hp700_hpux10)
  SYS_INCLUDE := -I/usr/local/contrib/include -I/usr/local/contrib/mod/include \
                 -I/usr/include/bsd
endif

ifeq ($(HW_OS),hp_flow)
  SYS_INCLUDE := -I/usr/local/contrib/include -I/usr/local/contrib/mod/include \
                 -I/usr/include/bsd -DFLOW
endif

ifeq ($(HW_OS),hp_flow_aCC)
  SYS_INCLUDE := -I/usr/local/contrib/include -I/usr/local/contrib/mod/include \
                 -I/usr/include/bsd -DFLOW
endif

# On the PC, place quatlib in the directory ./quat.  No actual system
# includes should be needed.
ifeq ($(HW_OS),pc_cygwin)
